#include <SD.h>

#include <SPI.h>
#include <DHT.h>

#define DHTPIN 2
#define DHTTYPE DHT22
const int chipSelect = 4;

DHT dht(DHTPIN, DHTTYPE);
void setup() {
  // put your setup code here, to run once:
  dht.begin();
  Serial.begin(9600);

  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }


  Serial.print("Initializing SD card...");

  // see if the card is present and can be initialized:
  if (!SD.begin(chipSelect)) {
    Serial.println("Card failed, or not present");
    // don't do anything more:
    while (1);
  }
  Serial.println("card initialized.");
}

/* void writeSD(dataString) {
  File dataFile = SD.open("datalog.txt", FILE_WRITE);

  // if the file is available, write to it:
  if (dataFile) {
    dataFile.println(dataString);
    dataFile.close();
    // print to the serial port too:
    Serial.println(dataString);
  }
  // if the file isn't open, pop up an error:
  else {
    Serial.println("error opening datalog.txt");
  }
}
*/
void loop() {
  float h = dht.readHumidity();
  float t = dht.readTemperature();

  if (isnan(t) || isnan(h)){
    Serial.println("Failed to read from DHT");
    return;
  }
    Serial.print("Hezetasuna:");
    Serial.print(h);
    Serial.println("");

    Serial.print("Tenperatura:");
    Serial.print(t);    
    Serial.println("");
    
    String dataString = "";
    dataString = String(h) + ";" + String(t) + ";";
    Serial.print("dataString:");
    Serial.println(dataString + "\n");

  File dataFile = SD.open("datalog.txt", FILE_WRITE);

  // if the file is available, write to it:
  if (dataFile) {
    dataFile.println(dataString);
    dataFile.close();
    // print to the serial port too:
    Serial.println(dataString);
  }
  // if the file isn't open, pop up an error:
  else {
    Serial.println("error opening datalog.txt");
  }

  
    delay(5000);
}

/*
Sketch uses 16430 bytes (53%) of program storage space. Maximum is 30720 bytes.
Global variables use 1053 bytes (51%) of dynamic memory, leaving 995 bytes for local variables. Maximum is 2048 bytes.

*/
