#include <SD.h>

#include <SPI.h>
#include <DHT.h>
#include <DS3231.h>


#define DHTPIN 2
#define DHTTYPE DHT22
const int chipSelect = 4;

//real time clock ds3231
DS3231  rtc(SDA, SCL);
DHT dht(DHTPIN, DHTTYPE);

void setup() {
    dht.begin();
    rtc.begin();
    Serial.begin(9600);

    ; // wait for serial port to connect. Needed for native USB port only
    while (!Serial) { }

    Serial.print("Initializing SD card...");

    if (!SD.begin(chipSelect)) {
        Serial.println("Card failed, or not present");
        while (1);
    }
    Serial.println("card initialized.");
}

void visualize(float h, float t, String data) {

    Serial.print("Hezetasuna:");
    Serial.print(h);
    Serial.println("");

    Serial.print("Tenperatura:");
    Serial.print(t);
    Serial.println("");

    Serial.print("dataString:");
    Serial.println(data + "\n");
}
void getAndWrite(){
    float h = dht.readHumidity();
    float t = dht.readTemperature();
    double unixTime = rtc.getUnixTime(rtc.getTime());

    if (isnan(t) || isnan(h)){
        Serial.println("Failed to read from DHT");
        return;
    }
    String dataString = "";
    dataString = String(h) + ";" + String(t) + ";" + String(unixTime);

    visualize(h, t, dataString);
    writeSD(dataString);
  
}


void loop() {
    getAndWrite();
    delay(5000);
}
